  subroutine nebanalysis
    use variables
    use constants
    double precision, allocatable :: rxn(:,:),ryn(:,:),rzn(:,:)
    double precision, allocatable :: fxn(:,:),fyn(:,:),fzn(:,:)
    double precision, allocatable :: vxn(:,:),vyn(:,:),vzn(:,:)
    double precision, allocatable :: tx(:),ty(:),tz(:)
    double precision, allocatable :: sx(:),sy(:),sz(:)
    double precision, allocatable :: eneb(:)
    double precision :: xx, yy, zz
    integer :: i, j, icnt
    character (3) :: stri,strj
    double precision :: spr = 5.0d2
    double precision :: fac = 1.0d-3
    double precision :: dtn
    dtn = neb_dt

    allocate (rxn(n,neb_num),ryn(n,neb_num),rzn(n,neb_num))
    allocate (fxn(n,neb_num),fyn(n,neb_num),fzn(n,neb_num))
    allocate (vxn(n,neb_num),vyn(n,neb_num),vzn(n,neb_num))
    allocate (tx(n),ty(n),tz(n))
    allocate (sx(n),sy(n),sz(n))
    allocate (eneb(neb_num))

    vxn=0.0; vyn=0.0; vzn=0.0
    fxn=0.0; fyn=0.0; fzn=0.0
    dt2=dtn/2.0
    dtsq2=dtn*dt2

! Set initial nodes
    call read_cfge(21,'conf-neb.cfge.ini')
    do i=1,n
       rx(i)=hmat(1,1)*qpx(i)+hmat(1,2)*qpy(i)+hmat(1,3)*qpz(i)
       ry(i)=hmat(2,1)*qpx(i)+hmat(2,2)*qpy(i)+hmat(2,3)*qpz(i)
       rz(i)=hmat(3,1)*qpx(i)+hmat(3,2)*qpy(i)+hmat(3,3)*qpz(i)
    enddo
    call bookkeep; call potential; eneb(1)=enpot
    do i=1,n
       rxn(i,1)=rx(i); ryn(i,1)=ry(i); rzn(i,1)=rz(i)
    enddo
    call read_cfge(21,'conf-neb.cfge.end')
    do i=1,n
       rx(i)=hmat(1,1)*qpx(i)+hmat(1,2)*qpy(i)+hmat(1,3)*qpz(i)
       ry(i)=hmat(2,1)*qpx(i)+hmat(2,2)*qpy(i)+hmat(2,3)*qpz(i)
       rz(i)=hmat(3,1)*qpx(i)+hmat(3,2)*qpy(i)+hmat(3,3)*qpz(i)
    enddo
    call bookkeep; call potential; eneb(neb_num)=enpot
    do i=1,n
       rxn(i,neb_num)=rx(i); ryn(i,neb_num)=ry(i); rzn(i,neb_num)=rz(i)
    enddo

    do i=1,n
       rx(i)=rxn(i,neb_num)-rxn(i,1)
       ry(i)=ryn(i,neb_num)-ryn(i,1)
       rz(i)=rzn(i,neb_num)-rzn(i,1)
    enddo
    call mkq
    do i=1,n
       xx=0.0; yy=0.0; zz=0.0
       if (qx(i)<-0.5) xx= 1.0; if (qx(i)> 0.5) xx=-1.0
       if (qy(i)<-0.5) yy= 1.0; if (qy(i)> 0.5) yy=-1.0
       if (qz(i)<-0.5) zz= 1.0; if (qz(i)> 0.5) zz=-1.0
       rxn(i,neb_num) = rxn(i,neb_num) + hmat(1,1)*xx+hmat(1,2)*yy+hmat(1,3)*zz
       ryn(i,neb_num) = ryn(i,neb_num) + hmat(2,1)*xx+hmat(2,2)*yy+hmat(2,3)*zz
       rzn(i,neb_num) = rzn(i,neb_num) + hmat(3,1)*xx+hmat(3,2)*yy+hmat(3,3)*zz
    enddo

    do i=1,n
       rx(i)=rxn(i,neb_num); ry(i)=ryn(i,neb_num); rz(i)=rzn(i,neb_num)
    enddo
    call bookkeep; call potential; eneb(neb_num)=enpot

    do j=2,neb_num-1
       do i=1,n
          xx = (rxn(i,neb_num) - rxn(i,1)) / dble(neb_num - 1)
          yy = (ryn(i,neb_num) - ryn(i,1)) / dble(neb_num - 1)
          zz = (rzn(i,neb_num) - rzn(i,1)) / dble(neb_num - 1)
          rxn(i,j) = rxn(i,1) + xx * dble(j - 1)
          ryn(i,j) = ryn(i,1) + yy * dble(j - 1)
          rzn(i,j) = rzn(i,1) + zz * dble(j - 1)
       enddo
    enddo
!    go to 1000

    open (30,FILE='eneb.d')
    open (35,FILE='nebtol.d')
    do icnt=1,neb_ite
       print *,'NEB step = ', icnt

! vv1
     do j=2,neb_num-1
       do i=1,n
          rxn(i,j) = rxn(i,j) + dtn*vxn(i,j) + dtsq2*fxn(i,j)/wm(i)
          ryn(i,j) = ryn(i,j) + dtn*vyn(i,j) + dtsq2*fyn(i,j)/wm(i)
          rzn(i,j) = rzn(i,j) + dtn*vzn(i,j) + dtsq2*fzn(i,j)/wm(i)
          vxn(i,j) = vxn(i,j) + dt2*fxn(i,j)/wm(i)
          vyn(i,j) = vyn(i,j) + dt2*fyn(i,j)/wm(i)
          vzn(i,j) = vzn(i,j) + dt2*fzn(i,j)/wm(i)
       enddo
    enddo

! Calculation of force exerting on each node
    do j=2,neb_num-1
       ! calc tangent
       xx=0.0
       do i=1,n
          tx(i)=rxn(i,j)-rxn(i,j-1); ty(i)=ryn(i,j)-ryn(i,j-1); tz(i)=rzn(i,j)-rzn(i,j-1)
          xx=xx+tx(i)**2+ty(i)**2+tz(i)**2
       enddo
       xx=sqrt(xx)
       yy=0.0
       do i=1,n
          tx(i)=rxn(i,j+1)-rxn(i,j); ty(i)=ryn(i,j+1)-ryn(i,j); tz(i)=rzn(i,j+1)-rzn(i,j)
          yy=yy+tx(i)**2+ty(i)**2+tz(i)**2
       enddo
       yy=sqrt(yy)
       do i=1,n
          tx(i)=(rxn(i,j)-rxn(i,j-1))/xx + (rxn(i,j+1)-rxn(i,j))/yy
          ty(i)=(ryn(i,j)-ryn(i,j-1))/xx + (ryn(i,j+1)-ryn(i,j))/yy
          tz(i)=(rzn(i,j)-rzn(i,j-1))/xx + (rzn(i,j+1)-rzn(i,j))/yy
         
       enddo
       ! calc cosine
       zz=0.0
       do i=1,n
          zz=zz+(rxn(i,j)-rxn(i,j-1))*(rxn(i,j+1)-rxn(i,j)) &
               +(ryn(i,j)-ryn(i,j-1))*(ryn(i,j+1)-ryn(i,j)) &
               +(rzn(i,j)-rzn(i,j-1))*(rzn(i,j+1)-rzn(i,j))
       enddo
       cos0 = zz/xx/yy

       ! normalize tangent vector
       do i=1,n
          xx=xx+tx(i)**2+ty(i)**2+tz(i)**2
       enddo
       xx=sqrt(xx)
       do i=1,n
          tx(i)=tx(i)/xx; ty(i)=ty(i)/xx; tz(i)=tz(i)/xx
       enddo
       ! calc dV (gradient of potential)
       do i=1,n
          rx(i)=rxn(i,j); ry(i)=ryn(i,j); rz(i)=rzn(i,j)
       enddo
       call potential; eneb(j)=enpot
       ! calc Fs (spring force)
       do i=1,n
          sx(i)=spr*(rxn(i,j+1)-rxn(i,j)) - spr*(rxn(i,j)-rxn(i,j-1))
          sy(i)=spr*(ryn(i,j+1)-ryn(i,j)) - spr*(ryn(i,j)-ryn(i,j-1))
          sz(i)=spr*(rzn(i,j+1)-rzn(i,j)) - spr*(rzn(i,j)-rzn(i,j-1))
       enddo
       
       ! calc force
       xx=0.0; yy=0.0
       do i=1,n
          xx=xx+fx(i)*tx(i)+fy(i)*ty(i)+fz(i)*tz(i)
          yy=yy+sx(i)*tx(i)+sy(i)*ty(i)+sz(i)*tz(i)
       enddo
       ff = 0.5d0*(1.0d0+cos(pi*cos0))
       do i=1,n
          f0x = fx(i) - xx*tx(i) + yy*tx(i)
          f0y = fy(i) - xx*ty(i) + yy*ty(i)
          f0z = fz(i) - xx*tz(i) + yy*tz(i)

          f1x = f0x + ff * (sx(i)-yy*tx(i))
          f1y = f0y + ff * (sy(i)-yy*ty(i))
          f1z = f0z + ff * (sz(i)-yy*tz(i))

          fxn(i,j)=0.0; fyn(i,j)=0.0; fzn(i,j)=0.0
          if (mfx(i)=='T') fxn(i,j) = f1x
          if (mfy(i)=='T') fyn(i,j) = f1y
          if (mfz(i)=='T') fzn(i,j) = f1z

       enddo
    enddo

    do j=1,neb_num
       write (30,999) j,eneb(j)
    enddo

999 format(i4,x,3e25.18)

! Optimization
! vv2
     do j=2,neb_num-1
       do i=1,n
          vxn(i,j) = vxn(i,j) + dt2*fxn(i,j)/wm(i)
          vyn(i,j) = vyn(i,j) + dt2*fyn(i,j)/wm(i)
          vzn(i,j) = vzn(i,j) + dt2*fzn(i,j)/wm(i)
       enddo
!       do i=1,n
!          rxn(i,j) = rxn(i,j) + fac * fxn(i,j)
!          ryn(i,j) = ryn(i,j) + fac * fyn(i,j)
!          rzn(i,j) = rzn(i,j) + fac * fzn(i,j)
!       enddo
    enddo

! damper
    do j=2,neb_num-1
       sp=0.0d0
       do i=1,n
          sp = sp+fxn(i,j)*vxn(i,j)+fyn(i,j)*vyn(i,j)+fzn(i,j)*vzn(i,j)
       enddo
       if (sp < 0.0) then
          do i=1,n
             vxn(i,j)=0.0d0; vyn(i,j)=0.0d0; vzn(i,j)=0.0d0
          enddo
       endif
    enddo
    
! convergence check
    xx=0.0d0
    do j=2,neb_num-1
       do i=1,n
          yy=fxn(i,j)**2; if (yy>xx) xx=yy
          yy=fyn(i,j)**2; if (yy>xx) xx=yy
          yy=fzn(i,j)**2; if (yy>xx) xx=yy
       enddo
    enddo
    write (35,*) icnt, sqrt(xx)
    if (sqrt(xx)<neb_tol) exit

    write (30,*)
    enddo
    close (30)
    close (35)

! Output
1000 continue
    do j=1,neb_num
       call conv_num_char2(j,strj)
       do i=1,n
          rx(i)=rxn(i,j); ry(i)=ryn(i,j); rz(i)=rzn(i,j)
       enddo
       call mkq
       call write_cfge(21,'conf-neb.cfge.'//strj)


       open (30,FILE='CONFIG.NEB.'//strj)
       call mkq
       if (multisystem==0) then
          write (30,*) asp(1)
       else
          write (30,*) 'Multi'
       endif
       write (30,*) potential_func, potential_arg
       write (30,*) n
       write (30,*) scl_lat
       do k=1,3
          xx=hmat(1,k)/ang; yy=hmat(2,k)/ang; zz=hmat(3,k)/ang
          xx=xx/scl_lat; yy=yy/scl_lat; zz=zz/scl_lat
          write (30,900) xx,yy,zz
       enddo
       write (30,*) 'fra'
       do i=1,n
          xx=qx(i); yy=qy(i); zz=qz(i)
          write (30,910) xx,yy,zz,asp(i),mfx(i),mfy(i),mfz(i)
       enddo
       close (30)

    enddo

 900  format (3(e26.19,1x))
 910  format (3(e26.19,1x),a3,1x,3(a2,1x))
 915  format (5(e26.19,1x))
 920  format (3(e26.19,1x),i10)

  end subroutine nebanalysis
