      program displvis
      implicit double precision (a-h,o-z)
      double precision, allocatable :: rx(:),ry(:),rz(:),vec(:)
      double precision, allocatable :: qx(:),qy(:),qz(:)
      double precision, allocatable :: rxn(:),ryn(:),rzn(:)
      double precision, allocatable :: qxn(:),qyn(:),qzn(:)
      double precision, allocatable :: fx(:),fy(:),fz(:)
      double precision :: hmat(3,3),hinmat(3,3)
      double precision :: xx,yy,zz,scl
      double precision :: ang=1.0d-10
      character  :: dmy
      character(13) :: filename
      character (3) :: fmt
      character (2) :: atom_species = 'Fe'
      integer :: iatom = 26
      integer :: atom_number
      double precision :: hart = 4.35982d-18 ! !Hr=4.35982d-18 J


      open (30,FILE='CONFIG',status='old',action='read',iostat=ierr)
      if (ierr/=0) then
         stop 'CANNOT FIND <CONFIG> FILE'
      endif
      if (ierr==0) then
         read (30,*) atom_species
         read (30,*) dmy
         read (30,*) n
         read (30,*) scl
         allocate (rx(n),ry(n),rz(n),vec(n))
         allocate (qx(n),qy(n),qz(n))
         allocate (fx(n),fy(n),fz(n))
         do j=1,3
            read (30,*) xx,yy,zz
            hmat(1,j)=xx*ang; hmat(2,j)=yy*ang; hmat(3,j)=zz*ang
         enddo
         hmat=hmat*scl
         read (30,*) fmt
         do i=1,n
            read (30,*) xx,yy,zz
            rx(i)=xx; ry(i)=yy; rz(i)=zz
         enddo
         if (fmt=='abs') then   ! cartesian coordinate
            rx=rx*ang; ry=ry*ang; rz=rz*ang
         else                   ! fractional coordinate
            do i=1,n
               xx=rx(i); yy=ry(i); zz=rz(i)
               rx(i)=hmat(1,1)*xx+hmat(1,2)*yy+hmat(1,3)*zz
               ry(i)=hmat(2,1)*xx+hmat(2,2)*yy+hmat(2,3)*zz
               rz(i)=hmat(3,1)*xx+hmat(3,2)*yy+hmat(3,3)*zz
            enddo
         endif
         close (30)
      endif

      open (30,FILE='CONFIG.END.FRA',status='old',action='read',iostat=ierr)
      if (ierr/=0) then
         stop 'CANNOT FIND <CONFIG> FILE'
      endif
      if (ierr==0) then
         read (30,*) dmy
         read (30,*) dmy
         read (30,*) n
         read (30,*) scl
         allocate (rxn(n),ryn(n),rzn(n))
         allocate (qxn(n),qyn(n),qzn(n))
         do j=1,3
            read (30,*) xx,yy,zz
            hmat(1,j)=xx*ang; hmat(2,j)=yy*ang; hmat(3,j)=zz*ang
         enddo
         hmat=hmat*scl
         read (30,*) fmt
         do i=1,n
            read (30,*) xx,yy,zz
            rxn(i)=xx; ryn(i)=yy; rzn(i)=zz
         enddo
         if (fmt=='abs') then   ! cartesian coordinate
            rxn=rxn*ang; ryn=ryn*ang; rzn=rzn*ang
         else                   ! fractional coordinate
            do i=1,n
               xx=rxn(i); yy=ryn(i); zz=rzn(i)
               rxn(i)=hmat(1,1)*xx+hmat(1,2)*yy+hmat(1,3)*zz
               ryn(i)=hmat(2,1)*xx+hmat(2,2)*yy+hmat(2,3)*zz
               rzn(i)=hmat(3,1)*xx+hmat(3,2)*yy+hmat(3,3)*zz
            enddo
         endif
         close (30)
      endif

      fx=rxn-rx; fy=ryn-ry; fz=rzn-rz
      do i=1,n
         if (fx(i)> hmat(1,1)/2.0) fx(i)=fx(i)-hmat(1,1)
         if (fx(i)<-hmat(1,1)/2.0) fx(i)=fx(i)+hmat(1,1)
         if (fy(i)> hmat(2,2)/2.0) fy(i)=fy(i)-hmat(2,2)
         if (fy(i)<-hmat(2,2)/2.0) fy(i)=fy(i)+hmat(2,2)
         if (fz(i)> hmat(3,3)/2.0) fz(i)=fz(i)-hmat(3,3)
         if (fz(i)<-hmat(3,3)/2.0) fz(i)=fz(i)+hmat(3,3)
      enddo

      xx=0.0d0
      do k=1,n
         xx=max(abs(fx(k)),xx)
         xx=max(abs(fy(k)),xx)
         xx=max(abs(fz(k)),xx)
      enddo
!      xx=xx*1.0d-2
      fx=fx/xx; fy=fy/xx; fz=fz/xx
      vec=sqrt(fx**2+fy**2+fz**2)


      filename='atomdispl.cfg'
      ifile=10

      open (ifile,FILE=filename)
      write (ifile,'(a22,i10)') 'Number of particles = ',n
      write (ifile,'(a4,f10.5,a9)') 'A = ',1.0,' Angstrom'
      write (ifile,'(a10,f10.5)') 'H0(1,1) = ',hmat(1,1)/ang
      write (ifile,'(a10,f10.5)') 'H0(1,2) = ',hmat(2,1)/ang
      write (ifile,'(a10,f10.5)') 'H0(1,3) = ',hmat(3,1)/ang
      write (ifile,'(a10,f10.5)') 'H0(2,1) = ',hmat(1,2)/ang
      write (ifile,'(a10,f10.5)') 'H0(2,2) = ',hmat(2,2)/ang
      write (ifile,'(a10,f10.5)') 'H0(2,3) = ',hmat(3,2)/ang
      write (ifile,'(a10,f10.5)') 'H0(3,1) = ',hmat(1,3)/ang
      write (ifile,'(a10,f10.5)') 'H0(3,2) = ',hmat(2,3)/ang
      write (ifile,'(a10,f10.5)') 'H0(3,3) = ',hmat(3,3)/ang
      write (ifile,'(a13)') '.NO_VELOCITY.'
      write (ifile,'(a15)') 'entry_count = 4'
      write (ifile,'(a36)') 'auxiliary[0] = evector[reduced unit]'
      write (ifile,'(f10.5)') 1.0000
      write (ifile,'(a2)') atom_species

      call inverse(hmat,hinmat)
      do k=1,n
         qx(k)=hinmat(1,1)*rx(k)+hinmat(1,2)*ry(k)+hinmat(1,3)*rz(k)
         qy(k)=hinmat(2,1)*rx(k)+hinmat(2,2)*ry(k)+hinmat(2,3)*rz(k)
         qz(k)=hinmat(3,1)*rx(k)+hinmat(3,2)*ry(k)+hinmat(3,3)*rz(k)
      enddo

      do i=1,n
         write (ifile,'(4f12.8)') qx(i),qy(i),qz(i),vec(i)
      enddo

      close (ifile)

      xx=xx*1.0d19
      fx=fx/xx; fy=fy/xx; fz=fz/xx
      filename='atomdispl.xsf'
      ifile=10

      open (ifile,FILE=filename)
      write (ifile,'(1x,a7)') 'CRYSTAL'
      write (ifile,'(1x,a7)') 'PRIMVEC'
      write (ifile,'(3f10.5)') hmat(1,1)/ang,hmat(2,1)/ang,hmat(3,1)/ang
      write (ifile,'(3f10.5)') hmat(1,2)/ang,hmat(2,2)/ang,hmat(3,2)/ang
      write (ifile,'(3f10.5)') hmat(1,3)/ang,hmat(2,3)/ang,hmat(3,3)/ang
      write (ifile,'(1x,a9)') 'PRIMCOORD'
      write (ifile,'(1x,i8,i8)') n,1
      do i=1,n
         write (ifile,'(i3,x,6f10.5)') atom_number(atom_species),rx(i)/ang,ry(i)/ang,rz(i)/ang,fx(i)/hart*ang,fy(i)/hart*ang,fz(i)/hart*ang
      enddo

      close (ifile)
      
      end


      subroutine inverse(a,b)
      implicit double precision (a-h,o-z)
      double precision a(3,3),b(3,3)
      do i=1,3
         do j=1,3
            b(i,j)=a(i,j)
         enddo
      enddo
      do 100 k=1,3
         p=b(k,k)
         b(k,k)=1.0d0
         do 1 j=1,3
            b(k,j)=b(k,j)/p
 1       continue
         do 2 i=1,3
            if (i.ne.k) then
               q=b(i,k)
               b(i,k)=0.0d0
               do 3 j=1,3
                  b(i,j)=b(i,j)-q*b(k,j)
 3             continue
            endif
 2       continue
 100  continue
      return
      end

      integer function atom_number(atom)
      use constants
      character(2) :: atom
      if ((atom=='C ').or.(atom=='c ')) then
         atom_number=6
      else if ((atom=='Cu').or.(atom=='cu')) then
         atom_number=29
      else if ((atom=='Al').or.(atom=='al')) then
         atom_number=13
      else if ((atom=='Si').or.(atom=='si')) then
         atom_number=14
      else if ((atom=='Ni').or.(atom=='ni')) then
         atom_number=28
      else if ((atom=='Fe').or.(atom=='fe')) then
         atom_number=26
      else if ((atom=='Ag').or.(atom=='ag')) then
         atom_number=47
      else if ((atom=='Au').or.(atom=='au')) then
         atom_number=79
      else if ((atom=='Pd').or.(atom=='pd')) then
         atom_number=46
      else if ((atom=='Pt').or.(atom=='pt')) then
         atom_number=78
      else
         atom_number=1
      endif
      end
